// Easy New Notebook
// Jeffrey J Weimer
// SVN History: $Revision: 631 $ on $Date: 2008-03-26 16:44:34 -0400 (Wed, 26 Mar 2008) $

#pragma rtGlobals=1

// PACKAGE GLOBAL FUNCTIONS

#pragma IgorVersion=6.03
#pragma version = 0.10
#pragma ModuleName=EasyNewNotebook

Function IgorMenuHook(isSel, menuStr, itemStr, itemNo, topWindowName, wt)
	Variable isSel, itemNo, wt
	String menuStr, itemStr, topWindowName

	Variable handled= 0
	switch(isSel)
		case 0:
			break
		case 1:
			if ( (cmpstr(menuStr,"New") == 0) && (cmpstr(itemStr,"Notebook") == 0) )
				Execute/P/Q/Z "ENN_CreateNewNotebook()"
				handled= 1
			endif
			break
	endswitch
	return handled
End

Function ENN_CreateNewNotebook()

	if (DataFolderExists("root:Packages:ENN")==0)
		string cdf=GetDataFolder(1)
		SetDataFolder root:
		NewDataFolder/O/S Packages
		NewDataFolder/O/S ENN
		string/G title
		variable/G left=0, right=200, top=0, bottom=300
		SetDataFolder $cdf
	endif
	ShowENNPanel()
	return 0
end

Static Function ShowENNPanel()

	SVAR title=root:Packages:ENN:title
	NVAR left=root:Packages:ENN:left
	NVAR right=root:Packages:ENN:right
	NVAR top=root:Packages:ENN:top
	NVAR bottom=root:Packages:ENN:bottom

	NewPanel/K=1/N=ENN_Panel/W=(150,77,416,166) as "Easy New Notebook"
	ModifyPanel noEdit=1,fixedSize=1
	Button doit,pos={212,66},size={50,20},proc=ENN_DoIt,title="Do It"
//	Button cancel,pos={161,66},size={50,20},title="Cancel",proc=ENN_Cancel
	CheckBox format,pos={142,25},size={65,14},title="Formatted",value= 1
	PopupMenu killstate,pos={167,43},size={88,21},title="Kill"
	PopupMenu killstate,mode=1,popvalue="Normal",value= #"\"Normal;Silent;NO KILL;Hide Only;\""
	SetVariable title,pos={7,7},size={250,16},title="Title"
	SetVariable title,value=title
	CheckBox ruler,pos={212,25},size={43,14},title="Ruler",value= 0
	SetVariable left,pos={5,66},size={70,16},title="<"
	SetVariable left,limits={10,600,10},value=left
	SetVariable top,pos={5,48},size={70,16},title="^"
	SetVariable top,limits={10,600,10},value=top
	SetVariable bottom,pos={84,66},size={70,16},title="v"
	SetVariable bottom,limits={10,600,10},value=bottom
	SetVariable right,pos={84,48},size={70,16},title=">"
	SetVariable right,limits={10,600,10},value=right
	PopupMenu name,pos={7,24},size={116,21},title="Name"
	PopupMenu name,mode=1,popvalue="From Title",value= #"\"From Title;Time Stamp;\""
End

Function ENN_DoIt(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	SVAR title=root:Packages:ENN:title
	NVAR left=root:Packages:ENN:left
	NVAR right=root:Packages:ENN:right
	NVAR top=root:Packages:ENN:top
	NVAR bottom=root:Packages:ENN:bottom

	variable format, kill, ruler
	string name

	switch( ba.eventCode )
		case 2: // mouse up
			ControlInfo format
			format = V_value
			ControlInfo killstate
			kill = V_value-1
			ControlInfo ruler
			ruler = V_value
			ControlInfo name
			if (V_value==1)
				name=CleanUpName(title,0)
			else
				name="Notebook"+CleanUpName(time(),0)
			endif
			NewNotebook/K=(kill)/F=(format)/N=$name as title
			if (format)
				Notebook $name showRuler=(ruler)
			endif
			KillWindow ENN_Panel
			break
	endswitch

	return 0
End
//
//Function ENN_Cancel(ba) : ButtonControl
//	STRUCT WMButtonAction &ba
//
//	switch( ba.eventCode )
//		case 2: // mouse up
//			KillWindow ENN_Panel
//			break
//	endswitch
//
//	return 0
//End
